{{Display Object}}


VAR

word ConfigAddress, ContentAddress
byte cogPTR
long Stack[100] 
byte InputFlag
byte UpButton, DownButton, LeftButton, RightButton, SelectButton, BackButton, IncButton, DecButton
byte OldYPos, YPos, OldXPos, XPos, PageNumb, PlateNumb

word DisplayAddress, SystemAddress, AFValueTableAddress, WIValueTableAddress, CogAddress, MapSensorAddress

OBJ

Debug:        "Debug_Lcd"
backup:       "Propeller Eeprom"
fs:           "FloatString"
fm:           "FloatMath"
Simple: "Simple_Serial"
Numb : "Simple_Numbers"       
 
PUB Start(DisplayValue, OutputPin, SystemFlag, AFValueTable, WIValueTable, Cog, MapSensor) : okay
{{
This method starts the Display object and returns a value that will be stored as the Cog Number for the Display object. 

}}
stop
okay := cogPTR := cognew(InitializeDisplay(DisplayValue, OutputPin, SystemFlag, AFValueTable, WIValueTable, Cog, MapSensor),@stack) + 1

PUB stop
{{
This method stops any previously executed Display Object and frees the Cog.

}}
  if cogPTR
    cogstop(cogPTR~ - 1)

PUB InitializeDisplay(DisplayValue, OutputPin, SystemFlag, AFValueTable, WIValueTable, Cog, MapSensorTable)
{{
This method initiates the LCD Screen, assigns the button pins to the buttons, assigns the SystemFlag variables to the local variables in this object, and begins the REPEAT loop
that will observe the navigation buttons and seek the menus that are selected. 

}}
debug.init(byte[OutputPin][0], 19200, 4)                                          
waitcnt(clkfreq + cnt)                              
debug.Backlight(true)
debug.cursor(0)
debug.cls                               

simple.init(31, 30, 19200)
simple.str(string("Hi"))
simple.tx(13)
dira[16..23]~

DisplayAddress := DisplayValue                          'Assign global variables to the variables that are passed on by the Main Cog
SystemAddress := SystemFlag
AFValueTableAddress := AFValueTable
WIValueTableAddress := WIValueTable
CogAddress := Cog
MapSensorAddress := MapSensorTable
                   
BackButton := 23   
SelectButton := 22 
UpButton := 21     
RightButton := 20  
LeftButton := 19   
DownButton := 18   
IncButton := 17    
DecButton := 16

long[SystemAddress][18] := 1                            'These flags hold the Main cog, until this one is ready to display.
long[SystemAddress][0] := 1

simple.str(string("Initalized"))
simple.tx(13)

GetBaseAddresses(0)                                     'Display MenuNumber 1 

PRI DisplaySplash | MenuNumber

MenuNumber := 0

simple.tx(13) 
simple.str(string("Displaying Splash Screens "))
simple.tx(13)

repeat 8                                                'There are eight Splash Screens
  InputFlag := 0
 
  debug.home
  debug.str(ContentAddress)

  simple.tx(13) 
  simple.str(string("Displaying Splash Screen: "))
  simple.str(numb.dec(MenuNumber))
  simple.tx(13)

  if MenuNumber == 1     
    DisplayVariable(CogAddress, 0, 6, 1, 0)
    DisplayVariable(CogAddress, 1, 6, 2, 0)
    DisplayVariable(CogAddress, 2, 6, 3, 0) 
    DisplayVariable(CogAddress, 3, 12, 1, 0)
    DisplayVariable(CogAddress, 4, 12, 2, 0)
    DisplayVariable(CogAddress, 6, 18, 1, 0)
    DisplayVariable(CogAddress, 5, 17, 3, 0)

  case byte[@@MenuNumberTable[MenuNumber+37]][3]
    0:
      WaitForInput
      if InputFlag == 2
        MenuNumber++
 
    other:
      simple.str(string("Display next screen in 2sec"))
      simple.tx(13)
      waitcnt(clkfreq*(byte[@@MenuNumberTable[MenuNumber+37]][3]) + cnt)
      MenuNumber++

simple.str(string("Complete")) 
simple.tx(13)
simple.tx(13)                   
simple.str(string("Display Menus")) 
simple.tx(13)

YPos := 1
GetBaseAddresses(10)

PRI DisplayMenu | MenuNumber

simple.tx(13)
simple.tx(13)
simple.tx(13)
simple.str(string("Displaying Menu Number: "))
simple.str(numb.dec(byte[ConfigAddress][2]))
simple.tx(13)

MenuNumber := byte[ConfigAddress][2]
 
simple.str(string("Confirm MenuNumber: "))
simple.str(numb.dec(MenuNumber))
simple.tx(13)

simple.str(string("Input Flag: "))
simple.str(numb.dec(InputFlag))
simple.tx(13)

waitcnt(clkfreq/2+cnt)

InputFlag := 0

simple.tx(13)
simple.str(string("Input Flag was reset to zero"))
simple.tx(13)
simple.tx(13)
simple.str(string("Starting REPEAT Loop"))
simple.tx(13)
      
repeat while InputFlag < 7
  debug.home
  debug.cls

  simple.str(string("Displaying Content"))
  simple.tx(13)

  debug.str(ContentAddress)

  simple.str(string("YPos: "))
  simple.str(numb.dec(YPos))
  simple.tx(13)

  debug.gotoxy(0, YPos)
  debug.putc(126)

  simple.tx(13)
  simple.str(string("Calling WaitForInput Method"))
  simple.tx(13)

  WaitForInput

  simple.tx(13)
  simple.str(string("Checking CASE InputFlag 1-6"))
  simple.tx(13)
    
  case InputFlag
    1:
      YPos--
      YPos #>= 1
      InputFlag := 0
      simple.str(string(">"))
      simple.str(string("YPos Change, Up"))
      simple.tx(13)
      simple.str(string("Leaving Case Loop, InputFlag = 1"))
      simple.tx(13)

    2:
      YPos++
      YPos <#= byte[ConfigAddress][1] - 1
      InputFlag := 0
      simple.str(string(">"))
      simple.str(string("YPos Change, Down"))
      simple.tx(13)
      simple.str(string("Leaving Case Loop, InputFlag = 2"))
      simple.tx(13)

    3..6 :
      InputFlag := 0
      simple.str(string(">"))
      simple.str(string("InputFlag reset to zero"))
      simple.tx(13)
      simple.str(string("Leaving Case Loop, InputFlag = 3..6"))
      simple.tx(13)

simple.str(string("Left REPEAT Loop, Checking CASE InputFlag 7-8 with InputFlag = "))
simple.str(numb.dec(InputFlag))
simple.tx(13)

case InputFlag
  7:
    simple.str(string(">"))
    simple.str(string("Current MenuNumber: "))
    simple.str(numb.dec(MenuNumber))
    simple.tx(13)

    MenuNumber := byte[ConfigAddress][3]
    YPos := byte[ConfigAddress][4]

    simple.str(string(">"))
    simple.str(string("Going BACK to Menu Number: "))
    simple.str(numb.dec(MenuNumber))

    simple.str(string(", with YPos: "))
    simple.str(numb.dec(YPos))
    simple.tx(13)
    
    GetBaseAddresses(MenuNumber)
    
  8:
    simple.str(string(">"))
    simple.str(string("Current MenuNumber: "))
    simple.str(numb.dec(MenuNumber))
    simple.tx(13)
    
    MenuNumber := byte[@@MenuNumberTable[MenuNumber+35]][4+YPos]
    YPos := 1      

    simple.str(string(">"))
    simple.str(string("Going AHEAD to Menu Number: "))
    simple.str(numb.dec(MenuNumber))

    simple.str(string(", with YPos: "))
    simple.str(numb.dec(YPos))
    simple.tx(13)

    GetBaseAddresses(MenuNumber)
   
PRI DisplayChoice | x, MenuNumber

simple.str(string("Displaying CHOICE MENU Number: "))
simple.str(numb.dec(byte[ConfigAddress][2]))
simple.tx(13)

simple.str(string("Displaying Input Flag: "))
simple.str(numb.dec(InputFlag))
simple.tx(13)

if InputFlag <> 7
  YPos := 1

YPos <#= byte[ConfigAddress][1] - 1  

InputFlag := 0

repeat while InputFlag < 7
  debug.home
  debug.cls

  debug.str(ContentAddress)

  repeat x from 0 to 2
    case byte[ConfigAddress][5+x]
      40:
        DisplayVariable(@WIEnable, 1, 15, 1, 1)

        simple.str(string("Displaying WIEnable Number: "))
        simple.str(numb.dec(40))
        simple.tx(13)
 
      41:
        DisplayVariable(@AFEnable, 1, 15, 2, 1)

        simple.str(string("Displaying AFEnable Number: "))
        simple.str(numb.dec(41))
        simple.tx(13)

      42:
        DisplayVariable(@FaultMonEnable, 1, 15, 3, 1)

        simple.str(string("Displaying FaultMonEnable Number: "))
        simple.str(numb.dec(42))
        simple.tx(13)

      50:
        DisplayVariable(@Stg1Cycle, 1, 15, 1, 2)

        simple.str(string("Displaying STG1Cycle Number: "))
        simple.str(numb.dec(50))
        simple.tx(13)

      51:
        DisplayVariable(@Stg2Cycle, 1, 15, 2, 2)

        simple.str(string("Displaying STG2Cycle Number: "))
        simple.str(numb.dec(51))
        simple.tx(13)

      52:
        DisplayVariable(@Stg3Cycle, 1, 15, 3, 2)

        simple.str(string("Displaying STG3Cycle Number: "))
        simple.str(numb.dec(52))
        simple.tx(13)

      60:
        DisplayVariable(@AFWarnEnable, 1, 15, 1, 1)

        simple.str(string("Displaying AFWarnEnable Number: "))
        simple.str(numb.dec(60))
        simple.tx(13)

      61:
        DisplayVariable(@AFWarnTPSValue, 1, 15, 2, 2)

        simple.str(string("Displaying AFWarnTPSValue Number: "))
        simple.str(numb.dec(61))
        simple.tx(13)

      62:
        DisplayVariable(@AFWarnValue, 1, 15, 3, 2)

        simple.str(string("Displaying AFWarnValue Number: "))
        simple.str(numb.dec(62))
        simple.tx(13)

      70:
        DisplayVariable(@LowWaterEnable, 1, 15, 1, 1)

        simple.str(string("Displaying LowWaterEnable Number: "))
        simple.str(numb.dec(70))
        simple.tx(13)

      71:
        DisplayVariable(@PumpIndEnable, 1, 15, 2, 1)

        simple.str(string("Displaying PumpIndEnable Number: "))
        simple.str(numb.dec(71))
        simple.tx(13)                              

  debug.gotoxy(0, YPos)
  debug.putc(126)

  WaitForInput

  case InputFlag
    1:
      YPos--
      YPos #>= 1
      InputFlag := 0
      simple.str(string("YPos Change, Up"))
      simple.tx(13)

    2:
      YPos++
      YPos <#= byte[ConfigAddress][1] - 1
      InputFlag := 0
      simple.str(string("YPos Change, Down"))
      simple.tx(13)

    3..6 : InputFlag := 0

case InputFlag
  7:
    MenuNumber := byte[ConfigAddress][3]
    YPos := byte[ConfigAddress][4]

    simple.str(string("Going BACK to Menu Number: "))
    simple.str(numb.dec(MenuNumber))
    simple.tx(13)

    GetBaseAddresses(MenuNumber)
    
  8:
    MenuNumber := byte[ConfigAddress][4+YPos]      

    simple.str(string("Going AHEAD to Edit Number: "))
    simple.str(numb.dec(MenuNumber))
    simple.tx(13)
          
    GetBaseAddresses(MenuNumber)
 

PRI DisplayStatus

PRI DisplayTable

PRI DisplayVariable(Address, Offset, x, y, Type)

debug.gotoxy(x,y)

case Type
  0: debug.dec(byte[Address][Offset])'CogNumbers
  1:
    if long[Address][Offset] == 1'Yes/No
      debug.str(string("Yes"))
    elseif long[Address][Offset] == 0
      debug.str(string("No"))      
            
  2: debug.str(fs.floattostring(long[Address][Offset])) 'FloatNumber, two digits, no suffix

PRI LoadMenuChar


PRI WaitForInput | x

x:=0               
InputFlag := 0

simple.tx(13)
simple.str(string("After Reset to zero, Input Flag: "))
simple.str(numb.dec(InputFlag))
simple.tx(13)

simple.str(string("Waiting for input"))

repeat until InputFlag <> 0
  if ina[UpButton]
    InputFlag := 1
    repeat while ina[UpButton]
    
  if ina[DownButton]
    InputFlag := 2
    repeat while ina[DownButton]
    
  if ina[LeftButton]
    InputFlag := 3
    repeat while ina[LeftButton]
    
  if ina[RightButton]
    InputFlag := 4
    repeat while ina[RightButton]
    
  if ina[IncButton]
    InputFlag := 5
    repeat while ina[IncButton]
    
  if ina[DecButton]
    InputFlag := 6
    repeat while ina[DecButton]
    
  if ina[BackButton]
    InputFlag := 7
    repeat while ina[BackButton]
    
  if ina[SelectButton]
    InputFlag := 8
    repeat while ina[SelectButton]

  x++
  
  if x // 10000 == 0
    simple.str(string("."))

simple.tx(13)
simple.str(string("Button Pressed, Input Flag: "))
simple.str(numb.dec(InputFlag))
simple.tx(13)  
waitcnt(clkfreq/4+cnt)
    
PRI MoveLeft

PRI MoveRight

PRI MoveUp

PRI MoveDown

PRI IncDecValue

PRI GetBaseAddresses(MenuNumber) : answer
                                                                           
case MenuNumber                                                            
  0..7:                                                                       
    ContentAddress := @@MenuNumberTable[MenuNumber]                                         
    ConfigAddress  := @@MenuNumberTable[MenuNumber+37]                     
    DisplaySplash
  10..15:
    ContentAddress := @@MenuNumberTable[MenuNumber-2]     
    ConfigAddress  := @@MenuNumberTable[MenuNumber+35] 
    DisplayMenu        
  20..25:
    ContentAddress := @@MenuNumberTable[MenuNumber-6]    
    ConfigAddress  := @@MenuNumberTable[MenuNumber+31]
    DisplayChoice     
  30..33:
    ContentAddress := @@MenuNumberTable[MenuNumber-10]    
    ConfigAddress  := @@MenuNumberTable[MenuNumber+27]
    DisplayStatus 
  40..42:
    ContentAddress := @@MenuNumberTable[MenuNumber-16]    
    ConfigAddress  := @@MenuNumberTable[MenuNumber+21]
    DisplayChoice 
  50..52:
    ContentAddress := @@MenuNumberTable[MenuNumber-23]    
    ConfigAddress  := @@MenuNumberTable[MenuNumber+14]
    DisplayChoice 
  60..62:
    ContentAddress := @@MenuNumberTable[MenuNumber-30]    
    ConfigAddress  := @@MenuNumberTable[MenuNumber+7]
    DisplayChoice 
  70..71:
    ContentAddress := @@MenuNumberTable[MenuNumber-37]    
    ConfigAddress  := @@MenuNumberTable[MenuNumber]
    DisplayChoice
  80..81:
    ContentAddress := @@MenuNumberTable[MenuNumber-45]    
    ConfigAddress  := @@MenuNumberTable[MenuNumber-8]
    DisplayTable

  
DAT
'                                     0,          1,            2,            3,            4,            5,            6,            7,          8,         9,         10,        11,           12,          13,              14,               15,                16,              17,               18,               19,        20,           21,              22,         23,        24,        25,              26,         27,         28,         29,            30,              31,           32,              33,             34,       35,       36,                37,               38,                 39,                 40,                 41,                 42,                 43,                 44,               45,              46,               47,              48,                 49,                50,                    51,                     52,                      53,                    54,                     55,                     56,              57,                 58,                    59,               60, 61, 62, 63, 64, 65, 66, 67, 68, 69, 70, 71,             72,             73
MenuNumberTable    word     @BootScreen, @CogScreen, @Disclaimer1, @Disclaimer2, @Disclaimer3, @Disclaimer4, @Disclaimer5, @Disclaimer6, @StartMenu, @MainMenu, @SetupMenu, @EditMenu, @UtilityMenu, @SensorMenu, @FeaturesChoice, @AFWarningChoice, @WIFeaturesChoice, @FaultMonChoice, @MapSensorChoice, @TPSSensorChoice, @WIStatus, @ClampStatus, @FaultMonStatus, @CogStatus, @WIEnable, @AFEnable, @FaultMonEnable, @Stg1Cycle, @Stg2Cycle, @Stg3Cycle, @AFWarnEnable, @AFWarnTPSValue, @AFWarnValue, @LowWaterEnable, @PumpIndEnable, @AFTable, @WITable, @BootScreenConfig, @CogScreenConfig, @Disclaimer1Config, @Disclaimer2Config, @Disclaimer3Config, @Disclaimer4Config, @Disclaimer5Config, @Disclaimer6Config, @StartMenuConfig, @MainMenuConfig, @SetupMenuConfig, @EditMenuConfig, @UtilityMenuConfig, @SensorMenuConfig, @FeaturesChoiceConfig, @AFWarningChoiceConfig, @WIFeaturesChoiceConfig, @FaultMonChoiceConfig, @MapSensorChoiceConfig, @TPSSensorChoiceConfig, @WIStatusConfig, @ClampStatusConfig, @FaultMonStatusConfig, @CogStatusConfig,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0, @AFTableConfig, @WITableConfig     
                       
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        
{Screen Content Arrays}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                 
{Menus}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                 
StartMenu              byte "SPAT-START MENU      Main                Setup                                  ", 0                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                          
MainMenu               byte "SPAT-MAIN MENU       Status Screens      Edit Tables                            ", 0                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                           
SetupMenu              byte "SPAT-SETUP           Features            Utility             Sensor Calibrate   ", 0                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                  
EditMenu               byte "SPAT-EDIT            A/F Table           Water Inj Table                        ", 0                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                 
UtilityMenu            byte "SPAT-SETUP-UTILITY   A/F Warning         WI Features         Fault Monitoring   ", 0                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            
SensorMenu             byte "SPAT-SETUP-SENSOR    MAP Sensor Cal      TPS Sensor Cal                         ", 0                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        
{Choice Menus}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                   
FeaturesChoice         byte "SPAT-SETUP-FEATURES  WI Enable:          A/F Enable:         FaultMon Enable:   ", 0                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                         
AFWarningChoice        byte "SPAT-SETUP-A/F WARN  A/F Warning:        TPS:                A/F:               ", 0                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                   
WIFeaturesChoice       byte "SPAT-SETUP WI FEAT.  Low Water:          Pump Ind:                              ", 0                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                 
FaultMonChoice         byte "SPAT-SETUP-FAULT MON STG1 CYC/MIN:       STG2 CYC/MIN:       STG3 CYC/MIN:      ", 0                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                 
MapSensorChoice        byte "SPAT-SETUP-MAP SENS  2.5 BAR             3.0 BAR                                ", 0                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                 
TPSSensorChoice        byte "SPAT-SETUP-TPS SENS  2.5 BAR             3.0 BAR                                ", 0                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                 
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                               
{Status- These can be removed and be replaced with a debug.cls command in the corresponding display}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                           
WIStatus               byte "                                                                                ",0                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                  
ClampStatus            byte "                                                                                ",0                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                  
FaultMonStatus         byte "                                                                                ",0                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                  
CogStatus              byte "                                                                                ",0                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                  
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                               
{Splash}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                       
BootScreen             byte "SPAT-               System Performance  and Adjustment      Terminal            ", 0                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                 
CogScreen              byte "COGS USED:          Spray:  ADC:  LCD:  Debug:  A/F:        Calc:   FaultMon:   ", 0                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                 
Disclaimer1            byte "WARNING: Damage to  your vehicle could  result from misuse  of this device.     ", 0                                                                                                                                                                                                                                                                                                                                                                                                                                
Disclaimer2            byte "Please consult the  owner's manual and  a qualified auto    technician for      ", 0                                                                                                                                                                                                                                                                                                                                                                                                                     
Disclaimer3            byte "installation and    tuning. The maker ofthis device is not  responsible for     ", 0                                                                                                                                                                                                                                                                                                                                                                                                                     
Disclaimer4            byte "damages caused by   misuse or not       heeding the warning mentioned previous. ", 0                                                                                                                                                                                                                                                                                                                                                                                                                     
Disclaimer5            byte "The user of this    device agrees with  this disclaimer by  scrolling through   ", 0                                                                                                                                                                                                                                                                                                                                                                                                                     
Disclaimer6            byte "this disclaimer     itself, waiving all liability of the    manufacturer.       ", 0                                                                                                                                                                                                                                                                                                                                                                                                                     
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                   
{Tables}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                           
AFTable                byte "SPAT-A/F Corr                                                                ", 0                                                                                                                                                                                                                                                                                                                                                                                                                     
WITable                byte "SPAT-WaterInj          STG1 STG2 STG3PSI                 RPM                 ", 0                                                                                                                                                                                                                                                                                                                                                                                                                     
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                   
{Config Data}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                      
{Menus                      MenuType, #ofLines, Menu#, Origin#, FromLine, 1stLineContent, 2ndLineContent, 3rdLineContent}                                                                                                                                                                                                                                                                                                                                                                                                          
StartMenuConfig        byte        0,        3,    10,      10,        1,             11,             12                                                                                                                                                                                                                                                                                                                                                                                                                           
MainMenuConfig         byte        0,        3,    11,      10,        1,             30,             13                                                                                                                                                                                                                                                                                                                                                                                                                           
SetupMenuConfig        byte        0,        4,    12,      10,        2,             20,             14,             15                                                                                                                                                                                                                                                                                                                                                                                                           
EditMenuConfig         byte        0,        3,    13,      11,        2,             80,             81                                                                                                                                                                                                                                                                                                                                                                                                                           
UtilityMenuConfig      byte        0,        4,    14,      12,        2,             21,             22,             23                                                                                                                                                                                                                                                                                                                                                                                                           
SensorMenuConfig       byte        0,        3,    15,      12,        3,             24,             25                                                                                                                                                                                                                                                                                                                                                                                                                           
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                   
{Choice Menus               MenuType, #ofLines, Menu#, Origin#, FromLine, 1stLineContent, 2ndLineContent, 3rdLineContent}                                                                                                                                                                                                                                                                                                                                                                                                          
FeaturesChoiceConfig   byte        1,        4,    20,      12,        1,             40,             41,             42                                                                                                                                                                                         
AFWarningChoiceConfig  byte        1,        4,    21,      14,        1,             60,             61,             62                                                                                                                                                                                         
WIFeaturesChoiceConfig byte        1,        3,    22,      14,        2,             70,             71                                                                                                                                                                                                         
FaultMonChoiceConfig   byte        1,        4,    23,      14,        3,             50,             51,             52                                                                                                                                                                                         
MapSensorChoiceConfig  byte        1,        4,    24,      15,        1,              0                                                                                                                                                                                                                         
TPSSensorChoiceConfig  byte        1,        4,    25,      15,        2,              0                                                                                                                                                                                                                         
                                                                                                                                                                                                                                                                                                                 
{Status                     MenuType, #ofLines, Menu#, Origin#, FromLine}                                                                                                                                                                                                                                        
WIStatusConfig         byte        2,        4,    30,      11,        1                                                                                                                                                                                                                                         
ClampStatusConfig      byte        2,        4,    31,      11,        1                                                                                                                                                                                                                                         
FaultMonStatusConfig   byte        2,        4,    32,      11,        1                                                                                                                                                                                                                                         
CogStatusConfig        byte        2,        4,    33,      11,        1                                                                                                                                                                                                                                         
                                                                                                                                                                                                                                                                                                                 
{Splash                     MenuType, #ofLines, Menu#, Time}                                                                                                                                                                                                                                                     
BootScreenConfig       byte        3,        4,     0,    2                                                                                                                                                                                                                                                      
CogScreenConfig        byte        3,        4,     1,    2                                                                                                                                                                                                                                                      
Disclaimer1Config      byte        3,        4,     2,    0                                                                                                                                                                                                                                                      
Disclaimer2Config      byte        3,        4,     3,    0                                                                                                                                                                                                                                                      
Disclaimer3Config      byte        3,        4,     4,    0                                                                                                                                                                                                                                                      
Disclaimer4Config      byte        3,        4,     5,    0                                                                                                                                                                                                                                                      
Disclaimer5Config      byte        3,        4,     6,    0                                                                                                                                                                                                                                                      
Disclaimer6Config      byte        3,        4,     7,    0                                                                                                                                                                                                                                                      
                                                                                                                                                                                                                                                                                                                 
{Choice Variables           MenuType, Value, Menu#, Origin#, Line#, SystemFlagOffset, DeltaValue}                                                                                                                                                                                                                
WIEnable               long        4,     1,    40,      20,     1,                0,          0                                                                                                                                                                                                                 
AFEnable               long        4,     1,    41,      20,     2,                1,          0                                                                                                                                                                                                                 
FaultMonEnable         long        4,     0,    42,      20,     3,                8,          0                                                                                                                                                                                                                 
Stg1Cycle              long        4,  10.0,    50,      23,     1,                9,        0.1                                                                                                                                                                                                                 
Stg2Cycle              long        4,  20.0,    51,      23,     2,               10,        0.1                                                                                                                                                                                                                 
Stg3Cycle              long        4,  30.0,    52,      23,     3,               11,        0.1                                                                                                                                                                                                                 
AFWarnEnable           long        4,     0,    60,      21,     1,                3,          0                                                                                                                                                                                                                 
AFWarnValue            long        4,  11.5,    62,      21,     3,                5,        0.1                                                                                                                                                                                                                 
AFWarnTPSValue         long        4,  80.0,    61,      21,     2,                4,        1.0                                                                                                                                                                                                                 
LowWaterEnable         long        4,     0,    70,      22,     1,                6,          0                                                                                                               
PumpIndEnable          long        4,     0,    71,      22,     2,                7,          0                                                                                                               
                                                                                                                                                                                                               
{Tables                     MenuType, Menu#, Origin#, Line#, #ofColumns, 1stRowXPos, 2ndRowXPos, 3rdRowXpos, 1stRowFlag, 2ndRowFlag, 3rdRowFlag, 1stRowOffset, 2ndRowOffset, 3rdRowOffset}                     
AFTableConfig          byte        5,    80,      13,     1,         16,          4,          3,          3,          0,          1,          1,            6,            6,            6                      
WITableConfig          byte        5,    81,      13,     2,          3,          0,          5,          6,         99,          2,          0,           99,            5,            5                      
                       
''Custom Characters for the Status Screens
LeftBorder              byte    $1F,$10,$10,$10,$10,$10,$10,$1F
TopBotBorder            byte    $1F,$00,$00,$00,$00,$00,$00,$1F
RightBorder             byte    $1F,$01,$01,$01,$01,$01,$01,$1F
Marker                  byte    $1F,$00,$0E,$0E,$0E,$0E,$00,$1F
Middle                  byte    $1F,$11,$11,$11,$11,$11,$11,$1F
MiddleMarker            byte    $1F,$11,$1F,$1F,$1F,$1F,$11,$1F
LeftMarker              byte    $1F,$10,$1E,$1E,$1E,$1E,$10,$1F
RightMarker             byte    $1F,$01,$0F,$0F,$0F,$0F,$01,$1F

Down                    byte    $04,$04,$04,$04,$15,$0E,$04,$00
Up                      byte    $04,$0E,$15,$04,$04,$04,$04,$00                                                                                                                                                